<!--
 * @Title: 
 * @Description: 
 * @Author: 893699165@qq.com
 * @Date: 2022-08-24 10:49:21
 * @LastEditors: 
 * @LastEditTime: 2022-08-24 10:49:21
-->
<template>
    <div>
        <el-row>

            <el-col :span="24">
                <basic-container>
                    <avue-crud :option="option" :table-loading="loading" :data="data" :page.sync="page"
                        :before-open="beforeOpen" ref="crud" v-model="form" :permission="permissionList"
                        @row-del="rowDel" @row-update="rowUpdate" @row-save="rowSave" @search-change="searchChange"
                        @search-reset="searchReset" @selection-change="selectionChange" @current-change="currentChange"
                        @size-change="sizeChange" @refresh-change="refreshChange" @on-load="onLoad"
                        @before-open="beforeOpen">
                        <template slot="state" slot-scope="{ row }">
                            <el-button type="text" @click="openConfig(row)"> 正常 </el-button>
                        </template>
                        <!-- <template slot-scope="{ row, index }" slot="menu">

              <el-button type="text" size="small" @click="warnSetting">预警配置
              </el-button>

            </template> -->
                    </avue-crud>
                </basic-container>
            </el-col>
        </el-row>


    </div>
</template>
  
<script>
import { getPage, getDetail, add, update, remove } from "@/api/project/projectPlan.js";

// import {
//   getDeptTree,
// } from "@/api/system/dept.js";

export default {
    components: {

    },
    props: {
        planSetting: {
            type: [Object],
            required: true
        },


    },
    name: 'projectPlan',
    data() {
        return {

            editForm: {},
            editDialog: false,
            form: {},
            selectionList: [],
            query: {},
            loading: true,
            page: {
                pageSize: 10,
                currentPage: 1,
                total: 0,
            },
            treeOption: {
                nodeKey: "id",
                lazy: true,
                treeLoad: function (node, resolve) {
                    const parentId = node.level === 0 ? 0 : node.data.id;
                    console.log(parentId)
                    console.log(resolve)
                    // getDeptLazyTree(parentId).then((res) => {
                    //   resolve(
                    //     res.data.data.map((item) => {
                    //       return {
                    //         ...item,
                    //         leaf: !item.hasChildren,
                    //       };
                    //     })
                    //   );
                    // });
                },
                addBtn: false,
                menu: false,
                size: "small",
                props: {
                    labelText: "标题",
                    label: "title",
                    value: "value",
                    children: "children",
                },
            },
            option: {
                labelWidth: 120,
                viewLabelWidth: 100,
                searchlabelWidth: 100,
                //height: "auto",
                height: 400,
                calcHeight: 30,
                align: "center",
                headerAlign: "center",
                lazy: false,
                tip: false,
                simplePage: true,
                searchShow: false,
                searchMenuSpan: 6,
                tree: false,
                border: true,
                index: true,
                selection: true,
                viewBtn: false,
                viewTitle: "计划信息",
                addBtn: true,
                editBtn: true,
                delBtn: true,
                menuWidth: 220,
                dialogType: "drawer",
                dialogClickModal: false,
                column: [
                    {
                        label: "计划名称",
                        prop: "planTitle",
                        span: 12,
                    },

                    {
                        label: "计划开始时间",
                        prop: "inspectionStartTime",
                        span: 12,
                        type: 'date'
                    },

                    {
                        label: "计划结束时间",
                        prop: "inspectionEndTime",
                        span: 12,
                        type: 'date'
                    },
                    {
                        label: "备注说明",
                        prop: "remark",
                        span: 8,
                    },

                ],
            },
            data: [],
        };
    },
    computed: {
        // ...mapGetters(["userInfo", "permission"]),
        permissionList() {
            return {
                // addBtn: this.vaildData(this.permission.docCategory_add, false),
                // viewBtn: this.vaildData(this.permission.docCategory_view, false),
                // delBtn: this.vaildData(this.permission.docCategory_delete, false),
                // editBtn: this.vaildData(this.permission.docCategory_edit, false),
            };
        },
        ids() {
            let ids = [];
            this.selectionList.forEach((ele) => {
                ids.push(ele.id);
            });
            return ids.join(",");
        },
    },
    mounted() {


    },
    created() {

        // this.query = {
        //     'orgId': this.planSetting.orgId,
        //     'projectId': this.planSetting.projectId,
        // }
        this.initData();
    },
    methods: {
        initData() {

            const planDate = new Date();

            const y = planDate.getFullYear();

            this.form = {
                'planTitle': this.planSetting.planTitle,
                'inspectionStartTime': "" + y + "-01-01",
                'inspectionEndTime': "" + y + "-12-31",
            };
            // this.form['planTitle'] = this.planTitle;
            // this.from['orgId'] = this.orgId;
            // this.from['projectId'] = this.projectId;
            // this.$message.success(this.planTitle)
            // getDeptTree('000000').then((res) => {
            //   const column = this.findObject(this.option.column, "orgId");
            //   column.dicData = res.data.data;
            // });
        },

        // confirmConfig() {

        // },
        // warnSetting(item) {
        //     this.configSw = item.configSw;
        //     this.configDialog = true;
        // },
        // openInfo(item) {
        //   this.id = item.id;
        //   this.infoDialog = true;
        //   this.$nextTick(() => {
        //     this.$refs["warningInfo"].init();
        //   });
        // },
        // openOrder(item) {
        //   this.id = item.id;
        //   this.orderDialog = true;
        //   this.$nextTick(() => {
        //     this.$refs["maintainOrder"].init();
        //   });
        // },

        rowSave(row, done, loading) {
            add(row).then(
                () => {
                    this.onLoad(this.page);
                    this.$message({
                        type: "success",
                        message: "操作成功!",
                    });
                    done();
                },
                (error) => {
                    window.console.log(error);
                    loading();
                }
            );
        },
        rowUpdate(row, index, done, loading) {
            update(row).then(
                () => {
                    this.onLoad(this.page);
                    this.$message({
                        type: "success",
                        message: "操作成功!",
                    });
                    done();
                },
                (error) => {
                    window.console.log(error);
                    loading();
                }
            );
        },
        rowDel(row) {
            this.$confirm("确定将选择数据删除?", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            })
                .then(() => {
                    return remove(row.id);
                })
                .then(() => {
                    this.onLoad(this.page);
                    this.$message({
                        type: "success",
                        message: "操作成功!",
                    });
                });
        },
        searchReset() {
            this.query = {
                'orgId': this.planSetting.orgId,
                'projectId': this.planSetting.projectId,
            }
            this.onLoad(this.page);
        },
        searchChange(params, done) {
            this.query = params;
            this.query['orgId'] = this.planSetting.projectId;
            this.query['projectId'] = this.planSetting.projectId;
            this.page.currentPage = 1;
            this.onLoad(this.page, params);
            done();
        },
        selectionChange(list) {
            this.selectionList = list;
        },
        selectionClear() {
            this.selectionList = [];
            this.$refs.crud.toggleSelection();
        },
        handleDelete() {
            if (this.selectionList.length === 0) {
                this.$message.warning("请选择至少一条数据");
                return;
            }
            this.$confirm("确定将选择数据删除?", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            })
                .then(() => {
                    return remove(this.ids);
                })
                .then(() => {
                    this.onLoad(this.page);
                    this.$message({
                        type: "success",
                        message: "操作成功!",
                    });
                    this.$refs.crud.toggleSelection();
                });
        },
        beforeOpen(done, type) {

            //     this.$message.success("beforeOpenbeforeOpenbeforeOpenbeforeOpenbeforeOpenbeforeOpenbeforeOpenbeforeOpen")

            //   this.query={
            //   'orgId':this.planSetting.orgId,
            //   'projectId':this.planSetting.projectId,
            // }
            //   if (["add", "edit"].includes(type)) {
            //     this.initData();
            //   }
            if (["edit"].includes(type)) {
                getDetail(this.form.id).then((res) => {
                    this.form = res.data.data;
                });
            }
            done();
        },
        currentChange(currentPage) {
            this.page.currentPage = currentPage;
        },
        sizeChange(pageSize) {
            this.page.pageSize = pageSize;
        },
        refreshChange() {
            this.onLoad(this.page, this.query);
        },
        onLoad(page, params = {}) {

            this.loading = true;
            getPage(
                page.currentPage,
                page.pageSize,
                Object.assign(params, this.query)
            ).then((res) => {
                const data = res.data.data;
                this.page.total = data.total;
                this.data = data.records;
                this.loading = false;
                this.selectionClear();
            });
        },
    },
};
</script>
  